/**
 * This is not a production server yet!
 * This is only a minimal backend to get started.
 */

import * as express from 'express';
import {db} from "./firestore/config";
import * as uuid from 'uuid'
import * as cors from 'cors'
import * as bodyParser from 'body-parser'

const app = express();

interface Bitacora {
    app: string,
    action: string,
    comment: string,
    cause: string,
}

const createFeedback = async (bitacora: Bitacora) => {
    return await db.collection('/TEST').doc('bitacora')
        .collection('feedbacks').add({
            ...bitacora,
            id: uuid.v1()
        })
}

app.use(bodyParser.urlencoded({extended: false}))
app.use(bodyParser.json());
app.use(cors())

app.post('/api', async (req, res) => {
    try {
        await createFeedback(req.body)
        return res.json({
            ok: true
        })
    } catch (e) {
        res.send({message: 'Welcome to cmpc-bitacora-api!'});
    }
});

const port = process.env.port || 3333;
const server = app.listen(port, () => {
    console.log(`Listening at http://localhost:${port}/api`);
});
server.on('error', console.error);
